//Cannon! Thank you Ephi for being sexy, and saving me the trouble of having to program most of this.
datablock PlayerData(CatapultTurret : PlayerStandardArmor)
{
	cameraVerticalOffset = 3;
	shapefile = "./Catapult.dts";
	canJet = 0;
	mass = 200000;
	//drag = 0.02;
	//density = 0.6;
	drag = 1;
	density = 5;
	runSurfaceAngle = 1;
	jumpSurfaceAngle = 0;
	maxForwardSpeed = 0;
	maxBackwardSpeed = 0;
	maxBackwardCrouchSpeed = 0;
	maxForwardCrouchSpeed = 0;
	maxSideSpeed = 0;
	maxSideCrouchSpeed = 0;
	maxStepHeight = 0;
	 maxUnderwaterSideSpeed = 0;

	uiName = "Catapult";
	showEnergyBar = false;
	
	jumpForce = 0; //8.3 * 90;
	jumpEnergyDrain = 10000;
	minJumpEnergy = 10000;
	jumpDelay = 127;
	minJumpSpeed = 0;
	maxJumpSpeed = 0;
	
	rideable = true;
	canRide = true;
	paintable = true;
	
	boundingBox			= vectorScale("3 3 2.4", 4);
	crouchBoundingBox	= vectorScale("3 3 2.4", 4);

	lookUpLimit = 0.6;
	lookDownLimit = 0.2;
	
	numMountPoints = 1;
	mountThread[0] = "root";
	
	upMaxSpeed = 1;
	upResistSpeed = 1;
	upResistFactor = 1;
	maxdamage = 300;
	minlookangle = -0.4;
	maxlookangle = 0.2;

	useCustomPainEffects = true;
	PainHighImage = "";
	PainMidImage  = "";
	PainLowImage  = "";
	painSound     = "";
	deathSound    = "";
};

datablock DebrisData(CatapultDebris)
{
	//emitters = "jeepDebrisTrailEmitter";
	emitters = "";

	shapeFile = "./CatapultDebris.dts";
	lifetime = 3.5;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(CatapultBaseExplosion)
{
	//explosionShape = "";
	lifeTimeMS = 150;

	soundProfile = vehicleExplosionSound;
	
	emitter[0] = vehicleExplosionEmitter;
	emitter[1] = vehicleExplosionEmitter2;
	//emitter[0] = "";
	//emitter[1] = "";

	debris = CatapultDebris;
	debrisNum = 1;
	debrisNumVariance = 0;
	debrisPhiMin = 0;
	debrisPhiMax = 360;
	debrisThetaMin = 0;
	debrisThetaMax = 20;
	debrisVelocity = 18;
	debrisVelocityVariance = 3;

	faceViewer     = true;
	explosionScale = "1 1 1";

	shakeCamera = true;
	camShakeFreq = "7.0 8.0 7.0";
	camShakeAmp = "10.0 10.0 10.0";
	camShakeDuration = 0.75;
	camShakeRadius = 15.0;

	// Dynamic light
	lightStartRadius = 0;
	lightEndRadius = 20;
	lightStartColor = "0.45 0.3 0.1";
	lightEndColor = "0 0 0";

	//impulse
	impulseRadius = 15;
	impulseForce = 1000;
	impulseVertical = 2000;

	//radius damage
	radiusDamage        = 0;
	damageRadius        = 8.0;

	//burn the players?
	playerBurnTime = 5000;

};

datablock ProjectileData(CatapultBaseExplosionProjectile)
{
	directDamage        = 0;
	radiusDamage        = 0;
	damageRadius        = 0;
	explosion           = CatapultBaseExplosion;

	directDamageType  = $DamageType::jeepExplosion;
	radiusDamageType  = $DamageType::jeepExplosion;

	explodeOnDeath		= 1;

	armingDelay         = 0;
	lifetime            = 10;
};

function CatapultTurret::onDisabled(%this,%obj,%state)
{
	%p = new Projectile()
	{
		dataBlock = CatapultBaseExplosionProjectile;
		initialPosition = %obj.gettransform();
		initialVelocity = "0 0 1";
		client = %obj.lastDamageClient;
		sourceClient = %obj.lastDamageClient;
	};
	MissionCleanup.add(%p);
	%obj.hideNode("cannonball");
	%obj.hideNode("arm");
	%obj.setNodeColor("ALL", "0.2 0.2 0.2");

	%obj.schedule(3000,removebody);
	%player = %obj.getMountedObject(0);

	//boot out the driver
	%driver = %obj.getMountedObject(0);
	if(isObject(%driver))
		%driver.getdatablock().dodismount(%driver);

	//remove the burning fuse
	%obj.unMountImage(2); 
	
	%obj.burn(5);
}

package CatapultPackage
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%mount = %obj.getObjectMount();

		//hack so we can shoot if we ARE a cannon
		if(%obj.getDataBlock().getID() == CatapultTurret.getID())
			%mount = %obj;

		if(isObject(%mount) && (%obj == %mount || %obj.getControlObject() == %mount))
		{
			if(%mount.getDataBlock().getId() == CatapultTurret.getId() && %triggerNum == 0 )
			{
				if(%val == 1)
				{
					%client = %obj.client;
					if(isObject(%client))
						ServerCmdUnUseTool(%client);

					if(getSimTime() - %mount.lastShotTime < 2500)
					{
						cancel(%mount.stsched);
						return;
					}
					%mount.shotpower = 0;
					CatapultStrengthLoop(%mount);
					return;
				}
				else
				{
					cancel(%mount.stsched);
					if(%mount.shotpower != 0)
					{
						schedule(400, %obj, CatapultFire, %this, %obj, %triggerNum, %val, %mount);
						%mount.playThread(0, fire);
						return;
					}
				}
			}
		}
		
		Parent::onTrigger(%this,%obj,%triggerNum,%val);
	}

	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if(%col.getDataBlock().getId() == CatapultTurret.getId())
		{
			%client = %obj.client;
			if(isObject(%client))
				ServerCmdUnUseTool(%client);
		}
	}
};
activatepackage(CatapultPackage);

function CatapultFire(%this, %obj, %triggerNum, %val, %mount)
{
	%client = %obj.client;
	if(isObject(%client))
		ServerCmdUnUseTool(%client);

	if(getSimTime() - %obj.lastShotTime < 2500)
		return;

	%scaleFactor = getWord(%mount.getScale(), 2);
	%mount.ShotPower += 4;
	%vel = vectorScale(vectorNormalize(vectorAdd(%mount.getForwardVector(), "0 0 0.5")), %mount.shotpower * 0.5 * 3.5 * %scaleFactor);
	
	%p = new Projectile()
	{
		dataBlock       = CannonBallProjectile;
		initialPosition = %mount.getSlotTransform(2);
		initialVelocity = %vel;
		sourceObject    = %obj;
		client          = %obj.client;
		sourceSlot      = 0;
		originPoint     = vectorAdd( %mount.getEyeTransform(), vectorScale(%mount.getEyeVector(), 3) );
	};
	MissionCleanup.add(%p);
	%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);

	%mount.unMountImage(2); 

	serverPlay3D(brickChangeSound, %obj.getPosition());

	%obj.playThread(0, activate);
	%mount.hideNode("cannonball");
	%mount.schedule(2500, unhideNode, "cannonball");
	%mount.schedule(500, playThread, 0, load);
	%mount.lastShotTime = getSimTime();
	%mount.shotpower = 0;
}

function CatapultStrengthLoop(%obj)
{
	cancel(%obj.stsched);

	%obj.ShotPower += 1;
	
	%client = %obj.getControllingClient();
	if(isObject(%client))
		bottomprintCatapultStrength(%client, %obj.shotpower);

	if(%obj.ShotPower >= 20)
		return;

	%obj.stsched = schedule(150, %obj, CatapultStrengthLoop, %obj);

	// %obj.mountImage(CannonFuseImage, 2);
} 

function bottomprintCatapultStrength(%client, %amount)
{
	%per = %amount;
	%maxcounters = 20;
	%foo = %maxcounters - %per;
	%char = "|";for(%a =0; %a<%per; %a++){%fchar = %char @ %fchar;}
	%char2 = "|";for(%b =0; %b<%foo; %b++){%ftchar = %char2 @ %ftchar;}
	bottomprint(%client, "<just:center><color:FF0000>Fire! <color:FFFFFF>:<color:FFFF00>" @ %fchar @ "<color:000000>" @%ftchar, 1, 1);
}
