datablock PlayerData(PlayerCatapultTurret : CatapultTurret)
{
	uiName = "Player Catapult";

	numMountPoints = 1;
	mountThread[0] = "root";
	mountThread[1] = "sit";
};

function PlayerCatapultTurret::onAdd(%this, %obj)
{
	%obj.hideNode("cannonball");
}

package PlayerCatapultPackage
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%mount = %obj.getObjectMount();

		if(isObject(%mount) && (%obj == %mount || %obj.getControlObject() == %mount))
		{
			if(%mount.getDataBlock().getId() == PlayerCatapultTurret.getId() && %triggerNum == 0 )
			{
				if(%val == 1)
				{
					%client = %obj.client;
					if(isObject(%client))
						ServerCmdUnUseTool(%client);

					if(getSimTime() - %mount.lastShotTime < 2500)
					{
						cancel(%mount.stsched);
						return;
					}
					%mount.shotpower = 0;
					CatapultStrengthLoop(%mount);
					return;
				}
				else
				{
					cancel(%mount.stsched);
					if(%mount.shotpower != 0)
					{
						schedule(400, %obj, PlayerCatapultFire, %this, %obj, %triggerNum, %val, %mount);
						%mount.mountObject(%obj, 1);
						%mount.playThread(0, fire);
						return;
					}
				}
			}
		}
		
		Parent::onTrigger(%this,%obj,%triggerNum,%val);
	}

	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if(%col.getDataBlock().getId() == PlayerCatapultTurret.getId())
		{
			%client = %obj.client;
			if(isObject(%client))
				ServerCmdUnUseTool(%client);
		}
	}
};
activatepackage(PlayerCatapultPackage);

function PlayerCatapultFire(%this, %obj, %triggerNum, %val, %mount)
{
	%client = %obj.client;
	if(isObject(%client))
		ServerCmdUnUseTool(%client);

	if(getSimTime() - %obj.lastShotTime < 2500)
		return;

	%scaleFactor = getWord(%mount.getScale(), 2);
	%mount.ShotPower += 4;
	%vel = vectorScale(vectorNormalize(vectorAdd(%mount.getForwardVector(), "0 0 0.5")), %mount.shotpower * 0.5 * 3.5 * %scaleFactor);
	
	%obj.dismount();
	%obj.setTransform(%mount.getSlotTransform(2));
	%obj.setVelocity(%vel);

	%mount.unMountImage(2); 

	serverPlay3D(brickChangeSound, %obj.getPosition());

	%mount.schedule(500, playThread, 0, load);
	%mount.lastShotTime = getSimTime();
	%mount.shotpower = 0;
}